// Fichier OBJETS.JS

// VARIABLES GLOBALES

	var classe="";
	var nom="";
	var prenom="";
	var txt_page="";
	var fen_guide=null;
	var timer=null;
	var flag=1;
	var af_themes=1;
	var af_questions=1;
	var nb_quest_total_afaire=0;
	var bareme_final=0;
	var note_final=0;
		
// CLASSE CL_text()

	function CL_text() {
		this.mdp_prof=new Array();
		this.titre=new Array();
		this.bouton=new Array();
		this.fenetre=new Array();
		this.mot=new Array();
		this.rappel_niveau=new Array();
		this.competence=new Array();
		this.division=new Array();
		this.score=new Array();
	}

// CLASSE CL_appr

	function CL_appr(a,b,c) {
		this.note_min=a*1;
		this.note_max=b*1;
		if (b*1<a*1) {
			this.note_min=b*1;
			this.note_max=a*1;
		}
		this.enonce=c;
	}

// CLASSE CL_page

	function CL_page(nom,adresse) {
		this.nom=nom;
		this.adresse=adresse;
	}

// CLASSE CL_option

	function CL_option() {
		this.mode_accueil=1;
		this.mode_questions=1;	
		this.mode_evaluation=1;
		this.titre="";
		this.commentaire="";
		this.nb_questions=new Array();
		this.bouton=new Array();
		this.conseil_debut="";
		this.conseil_fin="";
		this.quitter="";
		this.coef_rep_juste=1;
		this.coef_rep_nulle=0;
		this.coef_rep_fausse=-0.5;
		this.note_sur="";
		this.debut="";
		this.juste="";
		this.faux="";
		this.abandon="";
		this.appr=new Array();
		this.non_fini="";
		this.ajouter_bouton_sup=ajouter_bouton_sup;
		this.ajouter_appr=ajouter_appr;
	}
	function ajouter_bouton_sup(a,b) {
		this.bouton[this.bouton.length]=new CL_page(a,b);
	}
	function ajouter_appr(a,b,c) {
	this.appr[this.appr.length]=new CL_appr(a,b,c);
	}

//CLASSE CL_reponse

	function CL_reponse(txt) {
		var debut=txt.substring(0,3);
		// si question type case  cocher
		if (debut=="[x]"||debut=="[ ]") {
			this.enonce=txt.substring(4,txt.length);
			if (debut=="[x]") this.resultat="vrai"; else this.resultat="faux";
		}
		// si question type bouton radio
		else if (debut=="(x)"||debut=="(o)"||debut=="( )") {
			this.enonce=txt.substring(4,txt.length);
			if (debut=="(x)"||debut=="(o)") this.resultat="vrai"; else this.resultat="faux";
		}
		// si question type glisser / dposer images dans tableau
		else if (debut=="{ }") {
			this.titre=new Array(); // cration d'un tableau pour ranger les titres des collones du tableau
			this.image=new Array(); // cration d'un tableau pour ranger le chemin o se trouve les images
			this.larg=new Array(); // cration d'un tableau pour ranger les largeurs des images
			this.haut=new Array(); // cration d'un tableau pour ranger les hauteurs des images
			// prendre les caractres aprs { } pour mettre dans le tableau titre
			var pos=txt.indexOf("//");
			var pos1=txt.indexOf(",");
			this.titre=txt.substring(3,pos);
			// prendre les caractres aprs // pour mettre dans le tableau image : le chemin de l'image et sa taille
			this.image=txt.substring(pos+2,pos1);
			// prendre les caractres aprs la premire virgule, pour mettre dans le tableau larg : la largeur de l'image
			var dimensions=txt.substring(pos1+1,txt.length);
			var pos2=dimensions.indexOf(",");			
			this.larg=dimensions.substring(0,pos2);
			// prendre les caractres aprs la deuxime virgule, pour mettre dans le tableau haut : la hauteur de l'image
			this.haut=dimensions.substring(pos2+1,txt.length-1);
		}
		// si question type zone de texte [rponse1||rponse2||rponse3...]
		else {
			this.resultat=new Array();
			var pos=txt.indexOf("[");
			if (pos!=-1) {
				this.enonce=txt.substring(0,pos);
				var pos2=txt.indexOf("]");
				//var ch=txt.substring(pos+1,txt.length);
				var ch=txt.substring(pos+1,pos2);
				var pos=ch.indexOf("=>");
				if (pos==-1) {
					this.type="zone de texte";
					var pos=ch.indexOf("||");
					if (pos==-1) this.resultat[0]=ch;
					while (pos!=-1) {
						this.resultat[this.resultat.length]=ch.substring(0,pos);
						ch=ch.substring(pos+2,ch.length);
						pos=ch.indexOf("||");
						if (pos==-1) this.resultat[this.resultat.length]=ch;
					}
				}
				else {
					this.type="liste de selection";
	
// Pour la prochaine version!

				}
			}
			else {
				this.enonce=txt;
				this.resultat[0]="";
			}
		}
		this.repondu="";
	}
	
// CLASSE CL_question

	function CL_question(txt) {
		// recherche les arguments de la question : a = position de la rponse alatoire ou chiffre = bareme
		var pos=txt.indexOf("//");
		if (pos==-1) {			//
			this.enonce=txt;		//enonce de la question
			this.bareme=1;		// bareme = 1
			this.mode="ordre";  	// rponse toujours dans le mme ordre
		}
		else {
			this.enonce=txt.substring(0,pos);	// dfinit l'enonc du dbut de l'agrumlent question jusqu'au 2 slachs
			var opt=txt.substring(pos+2,txt.length);
			pos=opt.indexOf("a");			
			if (pos==-1) { 				// si argument aprs les 2 slachs = chiffre alors bareme = chiffre
				if (1*opt>0) this.bareme=1*opt; else this.bareme=1;
				this.mode="ordre";
			}
			else {					// si argument aprs les 2 slachs = lettre a alors rponse en ordre alatoire
				opt=opt.substring(0,pos)+opt.substring(pos+1,opt.length);
				if (1*opt>0) this.bareme=1*opt; else this.bareme=1;
				this.mode="aleatoire";
			}
		}
		this.etat="libre";
		this.schema="aucun"; //Images dans la question
		this.larg="";
		this.haut="";
		this.lien="aucun"; //lien hypertexte dans la question
		this.audio="aucun"; //fichier audio dans la question
		this.debut="";
		this.juste="";
		this.faux="";
		this.abandon="";
		this.reponse=new Array();
		this.bouton_indice=new Array();
		this.bouton_correction=new Array();
		this.ajouter_reponse=ajouter_reponse;
		this.ajouter_bouton_indice=ajouter_bouton_indice;
		this.ajouter_bouton_correction=ajouter_bouton_correction;
		this.ajouter_schema=ajouter_schema;
		this.ajouter_lien=ajouter_lien;
		this.ajouter_audio=ajouter_audio;
	}

	function ajouter_reponse(txt) {
		var debut=txt.substring(0,3);
		if (debut=="[x]"||debut=="[ ]") {
			this.type="cases a cocher";
			this.reponse[this.reponse.length]=new CL_reponse(txt);
		}
		else if (debut=="(x)"||debut=="(o)"||debut=="( )") {
			this.type="boutons radio";
			this.reponse[this.reponse.length]=new CL_reponse(txt);
		}
		// si question type glisser / dposer images dans tableau
		else if (debut=="{ }") {
			this.type="glisser dposer images";
			this.reponse[this.reponse.length]=new CL_reponse(txt);
		}
		// si question type zone de texte [rponse1||rponse2||rponse3...]
		else {
			this.type="autre";
			var pos=txt.indexOf("]");
			if (pos==-1) this.reponse[this.reponse.length]=new CL_reponse(txt+"<br>");
			while (pos!=-1) {
				var ch=txt.substring(0,pos+1);
				this.reponse[this.reponse.length]=new CL_reponse(ch);
				txt=txt.substring(pos+1,txt.length);
				pos=txt.indexOf("]");
				if (pos==-1) this.reponse[this.reponse.length]=new CL_reponse(txt+"<br>");
			}
		}
	}

	function ajouter_bouton_indice(a,b) {
		this.bouton_indice[this.bouton_indice.length]=new CL_page(a,b);
	}

	function ajouter_bouton_correction(a,b) {
		this.bouton_correction[this.bouton_correction.length]=new CL_page(a,b);
	}

	function ajouter_schema(txt,largeur,hauteur) {
		this.schema=txt;
		this.larg=largeur;
		this.haut=hauteur;
	}

	function ajouter_lien(txt) {
		this.lien=txt;
	}

	function ajouter_audio(txt) {
		this.audio=txt;
	}

// CLASSE CL_theme

	function CL_theme(txt) {
				// recherche les arguments du thme : chiffre aprs les 2 slachs = pourcentage EA / pourcentage A
					var pos=txt.indexOf("//");
					if (pos==-1) {			//
						this.titre=txt;		//enonce de la question
						this.critereEA=40;		// purcentage par dfaut 40% pour obtenir EA
						this.critereA=75;		// purcentage par dfaut 75% pour obtenirA
						//this.nbr_question_a_poser=1;		// Nombre de quesion  poser
						}
					else {
						this.titre=txt.substring(0,pos);	// dfinit l'enonc du dbut de l'argument question jusqu'au 2 slachs
						var pos2=txt.indexOf("#");
						this.critereEA=txt.substring(pos+2,pos2);	// purcentage par dfaut 40% pour obtenir EA
						this.critereA=txt.substring(pos2+1,txt.length);		// purcentage par dfaut 75% pour obtenirA
						//var opt=txt.substring(pos+2,txt.length);
						//	opt=opt.substring(0,pos)+opt.substring(pos+1,opt.length);
						//	if (1*opt>0) this.nbr_question_a_poser=1*opt; else this.nbr_question_a_poser=1;
						}
		this.note_obtenu=0;
		this.bareme_theme=0;
		this.etat="libre";
		this.choisi="non";
		this.question=new Array();
		this.ajouter_question=ajouter_question;
		
	}
	function ajouter_question(txt) {
		this.question[this.question.length]=new CL_question(txt);
	}
	
// CLASSE CL_qcm

	function CL_qcm() {
		this.theme=new Array();
		this.ajouter_theme=ajouter_theme;
	}
	
	function ajouter_theme(txt) {
		this.theme[this.theme.length]=new CL_theme(txt);
	}
	

// CLASSE CL_activite

	function CL_activite() {
		this.debut=null;
		this.fin=null;
		this.nb_quest_choisi=0;
		this.nb_quest_faites=0;
		this.num_theme=0;
		this.num_question=0;
		this.num_page="1";
		this.num_affichage=1;
		this.note=0;
		this.note_maxi=0;
	}


// CREATION DES OBJETS

	var texte=new CL_text();
	var option=new CL_option();
	var qcm=new CL_qcm();
	var activite=new CL_activite()
	var bougeimg=new CL_bougeimg();
	