// Fichier FONCTIONS.JS
//modif en cours fentre sans menu

// FONCTIONS APPELEES PAR LE FICHIER "textes.js"


	function titre(txt) {texte.titre[texte.titre.length]=txt;}
	function bouton(txt) {texte.bouton[texte.bouton.length]=txt;}
	function fenetre(txt) {texte.fenetre[texte.fenetre.length]=txt;}
	function mot(txt) {texte.mot[texte.mot.length]=txt;}
	function rappel_niveau(txt) {texte.rappel_niveau[texte.rappel_niveau.length]=txt;}
	function competence(txt) {texte.competence[texte.competence.length]=txt;}
	//function division(txt) {texte.division[texte.division.length]=txt;}
	function mdp_prof(txt) {texte.mdp_prof[texte.titre.length]=txt;}
	
// FONCTIONS APPELEES PAR LA PARTIE "OPTIONS" DU FICHIER "donnees.js"

	function mode_accueil(txt) {option.mode_accueil=txt;}
	function mode_questions(txt) {option.mode_questions=txt;}
	function mode_evaluation(txt) {option.mode_evaluation=txt;}
	function titre_introduction(txt) {option.titre+=" "+txt;}
	function introduction(txt) {option.commentaire+=" "+txt;}
	function bouton_sup(n,u) {option.ajouter_bouton_sup(n,u);}
	function message_debut(txt) {option.conseil_debut+=txt;}
	function message_fin(txt) {option.conseil_fin+=txt;}
	function url_quitter(txt) {option.quitter=txt;}
	function debut_defaut(txt) {option.debut=txt;}
	function juste_defaut(txt) {option.juste=txt;}
	function faux_defaut(txt) {option.faux=txt;}
	function abandon_defaut(txt) {option.abandon=txt;}
	function appreciation(note_min,note_max,txt) {option.ajouter_appr(note_min,note_max,txt);}
	function non_termine(txt) {option.non_fini=txt;}


// FONCTIONS APPELEES PAR LA PARTIE "QUESTIONNAIRE" DU FICHIER "donnees.js" qui permettent de donner les informations concernant le thme choisit

	function theme(txt) {qcm.ajouter_theme(txt);}

	function question(txt) {
		if (qcm.theme.length==0) qcm.ajouter_theme("Theme_non_defini");
		qcm.theme[qcm.theme.length-1].ajouter_question(txt);
		}

	function reponse(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].ajouter_reponse(txt);
		}

	function schema(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		if (schema.arguments.length==1) qcm.theme[num_theme].question[num_question].ajouter_schema(txt,"","");
		else {
			var l=schema.arguments[1];
			var h=schema.arguments[2];
			qcm.theme[num_theme].question[num_question].ajouter_schema(txt,l,h);
			}
		}

	function lien(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		if (lien.arguments.length==1) qcm.theme[num_theme].question[num_question].ajouter_lien(txt);
		else {
			qcm.theme[num_theme].question[num_question].ajouter_lien(txt);
			}
		}
		
	function audio(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		if (audio.arguments.length==1) qcm.theme[num_theme].question[num_question].ajouter_audio(txt);
		else {
				qcm.theme[num_theme].question[num_question].ajouter_audio(txt);
			}
		}	
		
	function bouton_indice(n,u) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].ajouter_bouton_indice(n,u);
		}

	function bouton_correction(n,u) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].ajouter_bouton_correction(n,u);
	}

	function debut(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].debut=txt;
	}

	function juste(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].juste=txt;
	}

	function faux(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].faux=txt;
	}

	function abandon(txt) {
		var num_theme=qcm.theme.length-1;
		var num_question=qcm.theme[num_theme].question.length-1;
		qcm.theme[num_theme].question[num_question].abandon=txt;
	}

// RACCOURCIS 

	function quest(txt) {question(txt);}
	function rep(txt) {reponse(txt);}
	function sch(txt) {
		if (sch.arguments.length==1) schema(txt);
		else {
			var l=sch.arguments[1];
			var h=sch.arguments[2];
			schema(txt,l,h);
		}
	}

// FONCTIONS POUR AFFICHER LA PAGE 1 A L'ECRAN (demande le nom, le prnom et la classe de l'lve)

	function ecrire_page1() {
		txt_page='<form name="f"><h1>'+option.titre+'</h1><h2>'+option.commentaire+'</h2>';
		// affichage du cadre choix de la classe
		txt_page+='<div style="float:left; width:5%;">&nbsp;</div>';
		//txt_page+='<div style="float:left; width:90%;">'+p1_afficher_division()+'</div>';
		//affichage du cadre nom et prnom
		txt_page+='<hr style="padding:0px; margin:0px; clear:both; visibility:hidden;">';
		txt_page+='<div class="cadre"><div class="titre_cadre">'+texte.titre[1]+'</div><div class="contenu_cadre" align="center">';
		txt_page+=texte.mot[0]+'<input type="text" name="ztnom"><BR><BR>';
		txt_page+=texte.mot[1]+'<input type="text" name="ztprenom">';
		txt_page+='</div></div>';
		txt_page+='<hr style="padding:0px; margin:0px; clear:both; visibility:hidden;">';
		txt_page+='<div id="menu">';
//Ajout du champ mot de passe prof
		txt_page+=texte.mot[8]+'<input type="password" name="ztmdp_prof" size="8">';
		txt_page+='<button type="button" onclick="parent.cache.p1_commencer();">'+texte.bouton[0]+'</button>';
			txt_page+='<button type="button" onclick="parent.cache.ouvrir_fenetre(\''+option.bouton[0].adresse+'\');">';
			txt_page+=option.bouton[0].nom+'</button>';
		//txt_page+='<button type="button" onclick="parent.cache.quitter_qcm();">'+texte.bouton[1]+'</button>';
		txt_page+='</div></form>';
		afficher_page();
		activite.num_page="1";
	}

	// affichage du tableau avec le choix des classes
	function p1_afficher_division(){
		var ch='<div class="cadre"><div class="titre_cadre">'+texte.titre[0]+'</div><div class="contenu_cadre">';
		// tableau  5 colonnes : 1 colone / niveau de classe 6eme 5eme 4eme 3eme autre
		ch+='<table width="95%" border="1" cellspacing="1" cellpadding="0" align="center" bgcolor="#FFFFFF">';
		//titres du tableau
		ch+='<TR>';
			ch+='<TD width="20%"><div class="titre_tableau">'+"Siximes"+'</div></TD>';
			ch+='<TD width="20%"><div class="titre_tableau">'+"Cinquimes"+'</div></TD>';
			ch+='<TD width="20%"><div class="titre_tableau">'+"Quatrimes"+'</div></TD>';
			ch+='<TD width="20%"><div class="titre_tableau">'+"Troisimes"+'</div></TD>';
			ch+='<TD width="20%"><div class="titre_tableau">'+"Autres"+'</div></TD>';
		ch+='</TR>';
		//contenu du tableau
		ch+='<TR>';
		ch+='<TD width="20%"> <div class="contenu_tableau">';
		//cration d'une colone par niveau de classe dans le tableau
		var chiffre_precedent=texte.division[0].substring(0,1);	
			for (var i=0;i<texte.division.length;i++) {
				var chiffre=texte.division[i].substring(0,1);
				if (chiffre==chiffre_precedent) {
					ch+='<input type="radio" name="choix">&nbsp;&nbsp;';
					ch+=texte.division[i].substring(0,3)+'<br>';
				}
				else {
					ch+='</TD>';
					ch+='<TD width="20%"> <div class="contenu_tableau">';
					ch+='<input type="radio" name="choix">&nbsp;&nbsp;';
					ch+=texte.division[i].substring(0,3)+'<br>';
					chiffre_precedent=chiffre
				}
			}
			ch+='</DIV></TD>';
		ch+='</TR>';
		ch+='</table>';
		ch+='</div></div>';
		return ch;
	}

	//vrifier si la classe est choisit et si le nom et le prnom est entre
	function p1_commencer() {
		//var commencer="non";
		var autorisation=1;
			for (var i=0;i<texte.division.length;i++) if (parent.pages.document.f.choix[i].checked) {
				//commencer="oui";
				classe=texte.division[i].substring(0,3);
				creneau_autorise=texte.division[i].substring(4); 
				jours = new Array('Dimanche', 'Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi', 'Samedi'); 
				aujourdhui=new Date();
				jour = jours[aujourdhui.getDay()]; // indique le jour d'aujourd'hui (lundi mardi...)
				heure   = aujourdhui.getHours();
				creneau1 = "hors_horaire";    
				creneau2 = "hors_horaire"; 
				switch (heure)
					{
  					case 8:
					creneau1 = "M1";
    				break;   
					case 9:
					creneau1 = "M2";
    				break;  
					case 10:
					creneau1 = "M3";
    				break; 
					case 11:
					creneau1 = "M4";
    				break; 
					case 13:
					creneau1 = "S1";
    				break; 
					case 14:
					creneau1 = "S1";
					creneau2 = "S2";
    				break; 
					case 15:
					creneau1 = "S2";
					creneau2 = "S3";
    				break; 
					case 16:
					creneau1 = "S3";
					creneau2 = "S4";
    				break;
					case 17:
					creneau1 = "S5";
    				break;
					}
				creneau_hor1=jour+creneau1;
				creneau_hor2=jour+creneau2;
				if(creneau_autorise.indexOf(creneau_hor1)!=-1 || creneau_autorise.indexOf(creneau_hor2)!=-1) autorisation=0; //autorisation = 0 si ok sinon retourne -1
			}
			//if (mdp prof pas bon) alert(texte.fenetre[0]);
			mdp_prof=parent.pages.document.f.elements["ztmdp_prof"].value;
	
			
			if (mdp_prof!=texte.mdp_prof[0]) alert(texte.fenetre[6]);// si autorisation diffrent de 0 alors pas d'accs
			else { 
				nom=parent.pages.document.f.elements["ztnom"].value;
				prenom=parent.pages.document.f.elements["ztprenom"].value;
				
				
				
				if (nom=="" || prenom=="") alert(texte.fenetre[1]);
				else {
					ecrire_page1bis();
					activite.num_page="1bis";
				}
			}
	}



// FONCTIONS POUR AFFICHER LA PAGE 1 bis A L'ECRAN

	function ecrire_page1bis() {
		// Remise  l'tat initial des paramtres.
		activite.nb_quest_faites=0;
		activite.note=0;
		activite.note_maxi=0;
		for (var i=0;i<qcm.theme.length;i++) {
			qcm.theme[i].etat="libre";
			for (var j=0;j<qcm.theme[i].question.length;j++) {
				qcm.theme[i].question[j].etat="libre";
			}
			if (qcm.theme[i].question.length==0) qcm.theme[i].etat="fini";
		}

	// Vrification de l'affichage des thmes et du nombre de questions
		if (option.mode_questions==1) {
		if (qcm.theme.length==1) af_themes=0;			// pas de thme dispo
		if (qcm.theme.length!=1) af_themes=1;			// plusieurs thme possible
		if (option.nb_questions.length==1) af_questions=0;	// pas de question dispo pour le thme
		if (option.nb_questions.length>1) af_questions=1;	// existence de question pour le thme
		}

	// Affichage de la page
		txt_page='<form name="f"><h1>'+option.titre+'</h1><h2>'+option.commentaire+'</h2>';
		txt_page+='<div style="float:left; width:10%;">&nbsp;</div>';
		txt_page+='<div style="float:left; width:80%;">'+p1bis_afficher_themes()+'</div>';
		txt_page+='<hr style="padding:0px; margin:0px; clear:both; visibility:hidden;">';
		txt_page+='<div id="menu">';
		txt_page+='<button type="button" onclick="parent.cache.p1bis_commencer();">'+texte.bouton[0]+'</button>';
		for (var i=0;i<option.bouton.length;i++) {
			txt_page+='<button type="button" onclick="parent.cache.ouvrir_fenetre(\''+option.bouton[1].adresse+'\');">';
			txt_page+=option.bouton[1].nom+'</button>';
			}
		//txt_page+='<button type="button" onclick="parent.cache.quitter_qcm();">'+texte.bouton[1]+'</button>';
		txt_page+='</div></form>';
		afficher_page();
		activite.num_page="1bis";
		p1bis_commencer();
	}




// FONCTIONS POUR AFFICHER LA PAGE 2 A L'ECRAN

	function ecrire_page2() {
		
		// Remise  l'tat initial des paramtres.
		var a=activite.num_theme;
		var b=activite.num_question;
		var c=qcm.theme[a].question[b].reponse.length;
		var d=qcm.theme[a].question[b].schema;
		var e=qcm.theme[a].question[b].lien;
		var f=qcm.theme[a].question[b].audio;
		var commentaire="";
		qcm.theme[a].bareme_theme+=qcm.theme[a].question[b].bareme;

		// Affecte  la variable commentaire le texte qui se trouve dans l'argument dbut_defaut ou dbut.question.theme
		if (option.debut!="") commentaire=hasard(option.debut);
		if (qcm.theme[a].question[b].debut!="") commentaire=qcm.theme[a].question[b].debut;

		// affiche les cadres
txt_page='<form name="f"><div class="cadre">';
		
		// cadre avec la comptence les critres d'valuation et le rsultat
		txt_page+='<div class="titre_comp">';
		// affichage du cadre note / bareme
		//txt_page+='<div style="border:0; float:right; width:30%; text-align:right;"><b>'+texte.mot[4]+'</b>';
		txt_page+='<div style="border:0; float:right; width:30%; text-align:right;">&nbsp;';
		//txt_page+='<input type="text" name="mot1" size="5" style="text-align:center;" ';
		txt_page+='<input type="hidden" name="mot1" size="5" style="text-align:center;" ';
		txt_page+='value="&nbsp;&nbsp;&nbsp;%">';
		txt_page+='</div>';	
		//affichage du titre de la comptence value
		//txt_page+='<b>Comptence : </b>'+qcm.theme[a].titre;
		// affichage du cadre critere d'valuation
		//txt_page+='<div style="border:0; text-align:left;"><br><b>'+texte.mot[9]+'</b>';
		txt_page+='<div style="border:0; text-align:left;">&nbsp;';
		//txt_page+='<span class="nonacquis">&nbsp;&nbsp;0%  '+qcm.theme[a].critereEA+'%&nbsp;&nbsp;</span>'; // Non acquis
		//txt_page+='<span class="encours">&nbsp;&nbsp;'+qcm.theme[a].critereEA+',1%  '+qcm.theme[a].critereA+'%&nbsp;&nbsp;</span>'; // En cours
		//txt_page+='<span class="acquis">&nbsp;&nbsp;'+qcm.theme[a].critereA+',1%  100%&nbsp;&nbsp;</span>'; // Acquis
		txt_page+='</div>';	
		txt_page+='</div>';
		
		
		
		
		
		
		txt_page+='<div class="contenu_cadre">';
		// affiche l'image si image existante	
			if (d!="aucun") {
			txt_page+='<div style="width:100%;">'; // Pour le bug "Peekaboo" d'IE6.
			txt_page+='<img src="'+d+'" style="border:0; float:right;"';
				if (qcm.theme[a].question[b].larg!="" && qcm.theme[a].question[b].larg!="") {
					txt_page+='width="'+qcm.theme[a].question[b].larg+'" height="'+qcm.theme[a].question[b].haut+'"';
				}
			txt_page+='>';
			}	

		// affiche l'enonce de la question
		//if (qcm.theme[a].question[b].enonce!="") txt_page+='<b>Consigne : </b>'+hasard(qcm.theme[a].question[b].enonce)+'<br><br>';
		if (qcm.theme[a].question[b].enonce!="") 
		{
			// affiche la lecture audio si elle existe
			if (f!="aucun") txt_page+='<div id="players">';
			txt_page+='<b>Question : </b>';
				if (f!="aucun")
				{
				txt_page+='<object type="application/x-shockwave-flash" data="dewplayer-vol.swf?mp3='+f+'" width="240" height="20" id="dewplayer-vol"><param name="wmode" value="transparent" /><param name="movie" value="dewplayer-vol.swf?mp3='+f+'" /></object>';
				}
			txt_page+=hasard(qcm.theme[a].question[b].enonce);

				if (f!="aucun") txt_page+='</div>'; 
			
		txt_page+='<br><br>'; 
		
		}
		var num=new Array();
		

			// Code java pour lecture audio de fichier mp3
			//var content = '<object type="application/x-shockwave-flash" data="dewplayer.swf?autostart=1&son='+f+'" width="0" height="0"><param name="movie" value="dewplayer.swf?autostart=1&son='+f+'" /><\/object>';
		//document.getElementById('player').innerHTML = content;
		
			//Ajout dans la page HTML du lien pour lire le fichier audio

			//txt_page+='<audio preload="auto" src="'+f+'" id="player_audio"> </audio> <a id="element_lecture">Cliquer ici pour couter la question</a> <br>'; 			
			
		
		// affiche le lien hypertexte si un lien existe
		txt_page+='</div><div class="contenu_cadre">';
			if (e!="aucun") {
			//txt_page+='<div style="width:100%;">'; // Pour le bug "Peekaboo" d'IE6.
			//window.blank.location.href=e;
			txt_page+='<a href="'+e+'" target="_blank"> Cliquez ici pour ouvrir le lien </a> <br><br>'; 
			}
			
		// affiche les rponses possibles soit dans l'ordre soit dans le dsordre
		if (qcm.theme[a].question[b].mode=="ordre") {
			for (var i=0;i<c;i++) num[i]=i;
		}
		else {
			var util=new Array();
			var recom=1;
			num[0]=Math.floor(c*Math.random());
			util[0]=num[0];
			for (var i=1;i<c;i++) {
				num[i]=Math.floor(c*Math.random());
				recom=1;
				while (recom==1) {
					recom=0;
					for (var j=0;j<util.length;j++) {
						if (num[i]==util[j]) {
							recom=1;
							num[i]=Math.floor(c*Math.random());
						}
					}
				}
				util[i]=num[i];
			}
		}
		//Question type case  cocher
		if (qcm.theme[a].question[b].type=="cases a cocher") {
			var k=0;
			for (var i=0;i<c;i++) {
				k=num[i];
				txt_page+='<input type="checkbox" name="case'+k+'">&nbsp;&nbsp;';
				txt_page+=qcm.theme[a].question[b].reponse[k].enonce+'<br>';
			}
		}
		//Question type bouton radio
		else if (qcm.theme[a].question[b].type=="boutons radio") {
			var enonce_tmp=new Array();
			var resultat_tmp=new Array();
			var k=0;
			for (var i=0;i<c;i++) {
				enonce_tmp[i]=qcm.theme[a].question[b].reponse[i].enonce;
				resultat_tmp[i]=qcm.theme[a].question[b].reponse[i].resultat;
			}
			for (var i=0;i<c;i++) {
				k=num[i];
				qcm.theme[a].question[b].reponse[i].enonce=enonce_tmp[k];
				qcm.theme[a].question[b].reponse[i].resultat=resultat_tmp[k];
			}
			for (var i=0;i<c;i++) {
				txt_page+='<input type="radio" name="ch_rep">&nbsp;&nbsp;';
				txt_page+=qcm.theme[a].question[b].reponse[i].enonce+'<br>';
			}
		}
		
		
		//Si question type glisser dposer une image alors afficher le tableau
		
		else if (qcm.theme[a].question[b].type=="glisser dposer images") {
				txt_page+='<div id="quiz">';  
				txt_page+='<div>';
				txt_page+='<table summary="emplacements pour dposer les objets" border="1" id="t1">'; //Cration du tableau
				txt_page+='<tr>'; // premire ligne avec les titres
			// cration d'une colonne par rponse
			for (var i=0;i<c;i++) { 
				txt_page+='<th class=titreglisserdeposer>';
				txt_page+=qcm.theme[a].question[b].reponse[i].titre;
				txt_page+='</th>';	
			}
			txt_page+='</tr>';	
			// cration d'une colonne par rponse
		    txt_page+='<tr id="rcpTD">';
			for (var i=0;i<c;i++) { 
				txt_page+='<td>&nbsp;</td>';
			}
			txt_page+='</tr>';	
			txt_page+='</table>';	
			txt_page+='</div>';
			//affichage des images dans un ordre au hasard
			var k=0;
				for (var i=0;i<c;i++) { 
				k=num[i];
				txt_page+='<div style="width:100%;">'; // Pour le bug "Peekaboo" d'IE6.
				txt_page+='<img id="dd'+k+'" src="'+qcm.theme[a].question[b].reponse[k].image+'" style="border:1; float:left;"';
				txt_page+='width="'+qcm.theme[a].question[b].reponse[k].larg+'" height="'+qcm.theme[a].question[b].reponse[k].haut+'"';
				txt_page+=' alt="">';	
				}
			txt_page+='<p id="resultat"></p>';
			//txt_page+='<p id="dragtxt"></p>';
			//txt_page+='<p id="bougetxt"></p>';
			//txt_page+='<p id="droptxt"></p>';
// scripts pour drag & drop
txt_page+='<script  type="text/javascript">';
txt_page+='ob=[];'; // Cration du tableau d'objet
//txt_page+='resultat.innerHTML=ob[0];';
txt_page+='D=document;'; //affecte le nom du dcoument ouvert  la variable D
txt_page+='ie=D.all?1:0;'; //variable ie = 1 Si internet explorer
txt_page+='op=window.opera?1:0;'; //Variable Op = 1 Si Opera
txt_page+='dtd=D.compatMode=="CSS1Compat"?1:0;'; // Variable dtd = 1 si Mozilla
txt_page+='ob[0]=D;';
txt_page+='db=ie&!op&&dtd?D.documentElement:D.body;'; // affecte le nom de l'lment sous la souris selon le type de navigateur
txt_page+='</script>';

txt_page+='<script  type="text/javascript">';
txt_page+='document.body.onmousedown = function drag(e) {';
txt_page+='el=ie?event.srcElement:e.target;';
txt_page+='if(!el.tagName){el=el.parentNode};';// si l'objet est dplaable
txt_page+='if (el.id.substr(0,2)=="dd" && ob[0]==D){';  // le capture
txt_page+='  ob[0]=el;el=D;'; 
txt_page+='  }';
txt_page+='return false;}';
txt_page+='</script>';


txt_page+='<script  type="text/javascript">';
txt_page+='document.body.onmousemove = function bouge(e) {';
txt_page+='sx=ie?D.scrollLeft:pageXOffset;'; //affecte la position gauche de l'lment  la variable sx
txt_page+='sy=ie?D.scrollTop:pageYOffset;';  //affecte la position haute de l'lment  la variable sy
txt_page+='px=ie?event.clientX+sx:e.pageX;';  //affecte la position gauche de la souris  la variable px
txt_page+='py=ie?event.clientY+sy:e.pageY;';  //affecte la position haute de la souris  la variable py
txt_page+='if(ob[0] != D){';
txt_page+='  with(ob[0].style){position="absolute";display="inline";';
txt_page+='    left=px+"px";top=py+3+"px";cursor="move";}}';
txt_page+='return false;}';
txt_page+='</script>';

txt_page+='<script  type="text/javascript">';
txt_page+='document.body.onmouseup = function drop(e) {';
txt_page+='el=ie?event.srcElement:e.target;';
txt_page+='if(!el.tagName){el=el.parentNode};';
txt_page+='if (el.id.substr(0,2)=="dd"){el=el.parentNode};'; // une case peut contenir plusieurs rponses
txt_page+='if (el.parentNode.id.substr(0,3) == "rcp" ){';  // si c'est bien une case rponse
txt_page+='  tag = el.parentNode.id.substr(3,6);'; // tag des cases rponse
txt_page+='  if(el.tagName == tag){';
txt_page+='    el.appendChild(ob[0]);'; // colle l'objet dans la case slectionne
txt_page+='    el.style.width = "auto";'; // ncessaire pour Gecko et opra dans le quizz2
txt_page+='    ob[0].style.position="";';
txt_page+='    ob[0]=D;'; // annule la slection
txt_page+='    }';
txt_page+='  }';
txt_page+='return false;}';
txt_page+='</script>';
			txt_page+='</div>';	
		}
	
		else {
			for (var i=0;i<c;i++) {
				txt_page+=qcm.theme[a].question[b].reponse[i].enonce;
				if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
					txt_page+='<input type="text" name="zt'+i+'" size=';
					txt_page+=qcm.theme[a].question[b].reponse[i].resultat[0].length+'>';
				}
			}
		}
		if (d!="aucun") txt_page+='</div>'; // Pour le bug "Peekaboo" d'IE6.
		txt_page+='<hr style="padding:0px; margin:0px; clear:both; visibility:hidden;"></div></div>';
		txt_page+='<div id="menu">';
		if (commentaire!="") txt_page+=commentaire+'<hr>';
		txt_page+='<button type="button" onclick="parent.cache.p2_verifier();">'+texte.bouton[2]+'</button>';
		//txt_page+='<button type="button" onclick="parent.cache.p2_ne_sais_pas();">'+texte.bouton[4]+'</button>';
		for (var i=0;i<qcm.theme[a].question[b].bouton_indice.length;i++) {
			txt_page+='<button type="button" ';
			txt_page+='onclick="parent.cache.ouvrir_fenetre(\''+qcm.theme[a].question[b].bouton_indice[i].adresse+'\');">';
			txt_page+=qcm.theme[a].question[b].bouton_indice[i].nom+'</button>';
		}
		//txt_page+='<button type="button" onclick="parent.cache.p2_arreter();">'+texte.bouton[5]+'</button>';
		txt_page+='</div></form>';
		if (qcm.theme[a].question[b].type!="cases a cocher" && qcm.theme[a].question[b].type!="boutons radio") {
			txt_page+='<script language="JavaScript">parent.pages.document.f.zt0.focus();</script>';
			
		}
		
		afficher_page();
		activite.num_page="2";

		
	}

// FONCTIONS POUR AFFICHER LA PAGE 3 A L'ECRAN

	function ecrire_page3() {
		var duree=Math.round((activite.fin.getTime()-activite.debut.getTime())/1000);
		var minutes=Math.floor(duree/60);
		var secondes=duree-60*minutes;
		var temps="";
		if (minutes==0) temps=secondes+" s";
		else {
			if (secondes==0) temps=minutes+" min";
			else temps=minutes+" min "+secondes+" s";
		}
		var comm="";
		txt_page='<form name="f"><h1>'+texte.titre[4]+'<br>';
		txt_page+="de "+nom+"  " +prenom+" de la classe de CM2"+'</h1>';
	// affichage des comptences values et des rsultats obtenus
		txt_page+='<div class="cadre"><div class="titre_cadre">'+texte.titre[5]+'</div>';
		txt_page+='<div class="contenu_cadre">';
		// tableau  2 colonnes : 1ere colone = liste des comptences values 2eme colone : niveau acquis
		txt_page+='<table width="95%" border="1" cellspacing="1" cellpadding="0" align="center" bgcolor="#FFFFFF">';
		//titres du tableau
		txt_page+='<TR>';
			txt_page+='<TD width="78%"><div class="titre_tableau">'+texte.mot[5]+'</div></TD>';
			txt_page+='<TD width="9%"><div class="titre_tableau">'+texte.mot[6]+'</div></TD>';
			txt_page+='<TD width="7%"><div class="titre_tableau">%</div></TD>';
			txt_page+='<TD width="6%"><div class="titre_tableau">'+texte.mot[7]+'</div></TD>';
		//contenu du tableau
		txt_page+='</TR>';
			for (var i=0;i<qcm.theme.length;i++) {
				if (qcm.theme[i].choisi=="oui") {
					var niveau_note=0;
					var pourcentage=0;
					if (qcm.theme[i].note_obtenu>0){
						var niveau_note=qcm.theme[i].note_obtenu/qcm.theme[i].bareme_theme;
						var pourcentage=Math.floor(niveau_note*100);
								if (qcm.theme[i].note_obtenu>qcm.theme[i].bareme_theme) 
									{alert(texte.fenetre[8]);
									window.top.location.href=option.quitter;
									}
					}
					txt_page+='<TR>';
					//txt_page+='<TD width="76%"><div class="contenu_tableau">'+qcm.theme[i].titre+'</div>';
					txt_page+='<TD width="76%"><div class="contenu_tableau">'+qcm.theme[i].titre+'<br>';

		txt_page+='<span class="nonacquis">&nbsp;&nbsp;0%  '+qcm.theme[i].critereEA+'%&nbsp;&nbsp;</span>'; // Non acquis
		txt_page+='<span class="encours">&nbsp;&nbsp;'+qcm.theme[i].critereEA+',1%  '+qcm.theme[i].critereA+'%&nbsp;&nbsp;</span>'; // En cours
		txt_page+='<span class="acquis">&nbsp;&nbsp;'+qcm.theme[i].critereA+',1%  100%&nbsp;&nbsp;</span>'; // Acquis
															
		txt_page+='</div>';	
					
					
					
					
					txt_page+='</TD>';
					txt_page+='<TD width="9%"><div align="center"><font color="#000000">'+qcm.theme[i].note_obtenu+" / "+qcm.theme[i].bareme_theme+'</font></div></TD>';
					txt_page+='<TD width="9%"><div align="center"><font color="#000000">'+pourcentage+" % "+'</font></div></TD>';
					//if (niveau_note==1) 
						//{
						//txt_page+='<TD width="6%"><div align="center" class="resultat_EXP"><font color="#000000"><img src="../../../evaluations/expert.jpg" alt="expert" width="52" height="50"> </font></div></TD>';
						//"../../../contenu_page/evaluations/expert.jpg"
						//}
						//else 
						//{
					if (niveau_note>=qcm.theme[i].critereA/100) txt_page+='<TD width="6%"><div align="center" class="resultat_A"><font color="#000000">'+"1"+'</font></div></TD>';
					if (niveau_note<qcm.theme[i].critereA/100 && niveau_note>qcm.theme[i].critereEA/100) txt_page+='<TD width="6%"><div align="center" class="resultat_EA"><font color="#000000">'+"2"+'</font></div></TD>';
					if (niveau_note<=qcm.theme[i].critereEA/100) txt_page+='<TD width="6%"><div align="center" class="resultat_NA"><font color="#000000">'+"9"+'</font></div></TD>';
					txt_page+='</TR>';
						//}
					txt_page+='</TR>';
				}
			}
		txt_page+='</table>';
		txt_page+='</div></div>';
		//Affichage du rappel de la signifaction des lettres pour le niveau acquis (A,B,C et D)
		//txt_page+='<div class="cadre"><div class="titre_cadre">'+texte.titre[7]+'</div>';
		//txt_page+='<div class="contenu_cadre_rappel">'
		//	for (var i=0;i<texte.rappel_niveau.length;i++) {
		//		txt_page+=texte.rappel_niveau[i]+'<BR>';
		//	}
		//txt_page+='</div></div>';

		//if (activite.nb_quest_faites==nb_quest_total_afaire) {
		//	var note_final=0;
		//	var bareme_final=0;
		//	for (var i=0;i<qcm.theme.length;i++) {
		//		if (qcm.theme[i].choisi=="oui") {
		//			note_final=note_final+qcm.theme[i].note_obtenu;
		//			bareme_final=bareme_final+qcm.theme[i].bareme_theme;
		//			}
		//	}
		//	if (note_final!=0) {
		//		var note=0;
		//		note=Math.round((note_final/bareme_final)*100)*0.2;	
		//	}
		//	else note=0;
		//	txt_page+='<div class="cadre"><div class="titre_cadre">'+texte.titre[6]+'</div>';
		//	txt_page+='<div class="contenu_cadre">'+note+" / 20"+'</div></div>';
		//}

		txt_page+='<div id="menu">';
		txt_page+='<button type="button" onclick="window.print();">'+texte.bouton[7]+'</button>';
		//txt_page+='<button type="button" onclick="parent.cache.quitter_qcm();">'+texte.bouton[1]+'</button>';
		txt_page+='</div></form>';
		afficher_page();
		activite.num_page="3";
	}

// FONCTIONS APPELEES DEPUIS LA PREMIERE PAGE

	//affiche le cadre avec la liste des comptence et les cases  cocher
	function p1bis_afficher_themes() {
		var ch='<div class="cadre"><div class="titre_cadre">'+texte.titre[2]+'</div><div class="contenu_cadre">';
 		if (option.mode_accueil==1) {
//			for (var i=0;i<qcm.theme.length;i++) {
				//ch+='<input type="checkbox" name="case'+i+'" onclick="parent.cache.p1bis_choisir_themes();">&nbsp;&nbsp;';
				ch+='SCIENCES ET TECHNOLOGIE : reprer les objets qui utilisent le principe du levier.<br><br>';
//			}
			ch+='<BR>'
			//ch+='<input type="checkbox" name="tous" onclick="parent.cache.p1bis_choisir_themes();">&nbsp;&nbsp;';
			//ch+=texte.mot[2];
		}
		ch+='</div></div>';
		return ch;
	}
	
	// fonction qui coche toutes les comptences en cochant la dernire case 
	function p1bis_choisir_themes() {
		if (parent.pages.document.f.tous.checked) {
			for (var i=0;i<qcm.theme.length;i++) parent.pages.document.f.elements["case"+i].checked=true;
		}
	}
	
  // modif a faire dans cette fonction
	function p1bis_commencer() {
		var verif_th="non";
		var verif_quest="non";
		//if (af_themes==0) {
			for (var i=0;i<qcm.theme.length;i++) qcm.theme[i].choisi="oui";
			verif_th="ok";
		//}
		//if (af_themes==1) {
		//	for (var i=0;i<qcm.theme.length;i++) {
		//		if (parent.pages.document.f.elements["case"+i].checked) qcm.theme[i].choisi="oui";
		//		else qcm.theme[i].choisi="non";
		//	}
		//	for (var i=0;i<qcm.theme.length;i++) {
		//		if (qcm.theme[i].choisi=="oui") { 
		//			nbr_total_de_question_a_faire=nbr_total_de_question_a_faire+qcm.theme[i].nbr_question_a_poser
		//			verif_th="ok";
		//			}
		//	}

		//	if (verif_th=="non") alert(texte.fenetre[0]);
		//}
		if (verif_th=="ok") {
			for (var i=0;i<qcm.theme.length;i++) if (qcm.theme[i].choisi=="oui") nb_quest_total_afaire+=qcm.theme[i].question.length;
		}
		
		activite.debut=new Date();
		if (option.conseil_debut!="") {
			var cons=hasard(option.conseil_debut);
			//alert(cons);
		}
		nouvelle_question();
	}


// FONCTIONS APPELEES DEPUIS LA DEUXIEME PAGE

function p2_verifier() {
	var a=activite.num_theme;
	var b=activite.num_question;
	var c=qcm.theme[a].question[b].reponse.length;
	var suite="";
	// Vrification de l'existence d'une rponse apporte par l'lve.
	if (qcm.theme[a].question[b].type=="cases a cocher") {
		suite="non";
		for (var i=0;i<c;i++) if (parent.pages.document.f.elements["case"+i].checked) suite="oui";
		if (suite=="non") alert(texte.fenetre[3]);
	}
	else if (qcm.theme[a].question[b].type=="boutons radio") {
		suite="non";
		for (var i=0;i<c;i++) if (parent.pages.document.f.ch_rep[i].checked) suite="oui";
		if (suite=="non") alert(texte.fenetre[3]);
	}
	else if (qcm.theme[a].question[b].type=="glisser dposer images") {
	suite="non";
	score=0;
	ob_present=c;
	//cases=document.getElementById("rcp"+tag).getElementsByTagName(tag);
	lignereponse=parent.pages.document.getElementById("rcpTD");
	cells = lignereponse.getElementsByTagName("td")
	for(var i=0;i<cells.length;i++){
	  if (cells[i].childNodes[1]){
    		if (cells[i].childNodes[1].id =="dd"+i) score+=1; 
		suite = "oui";
    	}
		else {suite = "pas finit";alert(texte.fenetre[3]);break;}
  	}
	if (suite=="non") alert(texte.fenetre[3]);
	}

	else {
		suite="oui";
		for (var i=0;i<c;i++) {
			if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
				if (sup_esp(parent.pages.document.f.elements["zt"+i].value)=="") suite="non";
			}
		}
		if (suite=="non") {
			repondu="non";
			for (var i=0;i<c;i++) if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
				if (sup_esp(parent.pages.document.f.elements["zt"+i].value)!="") repondu="oui";
			}
			if (repondu=="non") alert(texte.fenetre[3]);
			if (repondu=="oui") { if (confirm(texte.fenetre[3])) suite="oui"; }
		}
	}
	if (suite=="oui") {
		// Identification de la rponse et calcul de la note obtenue  la question.

//Modif en cours pour calcul de la note obtenu pour le thme pour ensuite dfinir le niveau acquis

		var repondu="juste";
		var note_question=0;
		if (qcm.theme[a].question[b].type=="cases a cocher") {
			qcm.theme[a].note_obtenu+=c	// donne a la variable note_obtenu le nombre de case bouton dispo dans la rponse
			for (var i=0;i<c;i++) {
				if (parent.pages.document.f.elements["case"+i].checked) {
					if (qcm.theme[a].question[b].reponse[i].resultat=="faux") {
						repondu="faux";
						qcm.theme[a].note_obtenu=qcm.theme[a].note_obtenu-1;
					}
				}
				else {
					if (qcm.theme[a].question[b].reponse[i].resultat=="vrai") {
						repondu="faux";
						qcm.theme[a].note_obtenu=qcm.theme[a].note_obtenu-2;
					}
				}
			}
		if (qcm.theme[a].note_obtenu<=0) {
			qcm.theme[a].note_obtenu=0;
			}
		}
		else if (qcm.theme[a].question[b].type=="boutons radio") {
			for (var i=0;i<c;i++) {
				if (parent.pages.document.f.ch_rep[i].checked) {
					if (qcm.theme[a].question[b].reponse[i].resultat=="faux") repondu="faux";
				}
				else {
					if (qcm.theme[a].question[b].reponse[i].resultat=="vrai") repondu="faux";
				}
			}
			if (repondu=="juste") {
				qcm.theme[a].note_obtenu=qcm.theme[a].note_obtenu+1;
			}
		}
		
		else if (qcm.theme[a].question[b].type=="glisser dposer images") {
		qcm.theme[a].note_obtenu+=score;
		qcm.theme[a].question[b].bareme=ob_present;
		if (score!=ob_present) repondu="faux";
		}
			
		
		else {
			var nb_cases=0;
			for (var i=0;i<c;i++) if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") nb_cases++;
			qcm.theme[a].note_obtenu+=nb_cases	// donne a la variable note_obtenu le nombre de case texte dispo dans la rponse
			//var bareme_case=qcm.theme[a].question[b].bareme/nb_cases;
			for (var i=0;i<c;i++) {
				if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
					if (sup_esp(parent.pages.document.f.elements["zt"+i].value)=="") case_repondu="rien";
					else {
						case_repondu="faux";
						var repon=parent.pages.document.f.elements["zt"+i].value;
						for (var j=0;j<qcm.theme[a].question[b].reponse[i].resultat.length;j++) {
							var result=qcm.theme[a].question[b].reponse[i].resultat[j];
							if (sup_esp(repon)==sup_esp(result)) case_repondu="juste";
						}
					}
					if (case_repondu=="juste") {
				//qcm.theme[a].note_obtenu+=qcm.theme[a].note_obtenu;
					}

					if (case_repondu=="faux") {
						//note_question+=option.coef_rep_fausse*bareme_case/option.coef_rep_juste;
						repondu="faux";
						qcm.theme[a].question[b].reponse[i].repondu="faux";
						qcm.theme[a].note_obtenu=qcm.theme[a].note_obtenu-1;

					}
					if (case_repondu=="rien") {
						//note_question+=option.coef_rep_nulle*bareme_case/option.coef_rep_juste;
						if (repondu!="faux") repondu="partiel";
						qcm.theme[a].question[b].reponse[i].repondu="faux";
						qcm.theme[a].note_obtenu=qcm.theme[a].note_obtenu-1;
					}
				}
			}
		}
		// Commentaire sur la rponse apporte par l'lve
		var commentaire="";
		if (repondu=="juste") {
			if (option.juste!="") commentaire=hasard(option.juste);
			if (qcm.theme[a].question[b].juste!="") commentaire=qcm.theme[a].question[b].juste;
		}
		if (repondu=="faux") {
			if (option.faux.length!=0) commentaire=hasard(option.faux);
			if (qcm.theme[a].question[b].faux!="") commentaire=qcm.theme[a].question[b].faux;
		}

		note_question=qcm.theme[a].note_obtenu;		
		p2_suite(note_question,commentaire);
		//if (repondu=="partiel" || repondu=="faux") p2_suivant();//p2_clignoter();
	}
note_final+=qcm.theme[a].note_obtenu;
bareme_final+=qcm.theme[a].question[b].bareme;
}



function p2_suite(note_question,commentaire) {
	var a=activite.num_theme;
	var b=activite.num_question;
	var nouv_men='';
	if (commentaire!="") nouv_men+=commentaire+'<hr>';
	nouv_men+='<button type="button" onclick="parent.cache.p2_suivant();">'+texte.bouton[3]+'</button>';
	for (var i=0;i<qcm.theme[a].question[b].bouton_correction.length;i++) {
		nouv_men+='<button type="button" ';
		nouv_men+='onclick="parent.cache.ouvrir_fenetre(\''+qcm.theme[a].question[b].bouton_correction[i].adresse+'\');">';
		nouv_men+=qcm.theme[a].question[b].bouton_correction[i].nom+'</button>';
	}
	if (activite.nb_quest_faites!=nb_quest_total_afaire-1) {
		//nouv_men+='<button type="button" onclick="parent.cache.p2_arreter();">'+texte.bouton[5]+'</button>';
	}
	var obj=parent.pages.document.getElementById("menu");
	obj.innerHTML=nouv_men;
	//parent.pages.document.f.mot1.value=Math.round(note_question*100)/100+'/'+(qcm.theme[a].question[b].bareme*qcm.theme[a].nbr_question_a_poser);
	//parent.pages.document.f.mot1.value=Math.round(note_question*100)/100+'/'+(qcm.theme[a].bareme_theme);
	parent.pages.document.f.mot1.value='0%';
	if (note_question!=0) {parent.pages.document.f.mot1.value=Math.round((note_question*100)/100/(qcm.theme[a].bareme_theme)*100)+'%';}
	activite.note+=note_question;
//	qcm.theme[a].bareme_theme+=qcm.theme[a].question[b].bareme;
	activite.note_maxi+=qcm.theme[a].question[b].bareme;
	qcm.theme[a].question[b].etat="corrigee";
	activite.nb_quest_faites++;
	activite.num_page="2bis";
p2_suivant();

}

function p2_suivant() {
	if (activite.nb_quest_faites==nb_quest_total_afaire) p2_terminer();
	else nouvelle_question();
}

function p2_arreter() {
	if (activite.nb_quest_faites==nb_quest_total_afaire) p2_terminer();
	else {
		if (confirm(texte.fenetre[4])) p2_terminer();
	}
}

function p2_terminer() {
	clearTimeout(timer);
	flag=1;
	activite.fin=new Date();
	ecrire_page3();
}

function p2_clignoter() {
	var a=activite.num_theme;
	var b=activite.num_question;
	var c=qcm.theme[a].question[b].reponse.length;
	if (flag==0) {
		if (qcm.theme[a].question[b].type=="cases a cocher") {
			for (var i=0;i<c;i++) {
				if (qcm.theme[a].question[b].reponse[i].resultat=="vrai") {
					parent.pages.document.f.elements["case"+i].checked=true;
				}
			}
		}
		else if (qcm.theme[a].question[b].type=="boutons radio") {
			for (var i=0;i<c;i++) {
				if (qcm.theme[a].question[b].reponse[i].resultat=="vrai") {
					parent.pages.document.f.ch_rep[i].checked=true;
				}
			}
		}
		else if (qcm.theme[a].question[b].type=="glisser dposer images") {
			lignereponse=parent.pages.document.getElementById("rcpTD");
				cells = lignereponse.getElementsByTagName("td");
					for(var i=0;i<cells.length;i++){
						cells[i].innerHTML = "<img src='"+qcm.theme[a].question[b].reponse[i].image+"' style='border=1 float:left width= '"+qcm.theme[a].question[b].reponse[i].larg+" height='"+qcm.theme[a].question[b].reponse[i].haut+"' alt=''>";
						parent.pages.document.getElementById("rcpTD").style.visibility='visible';
						}
		}			
		else {
			for (var i=0;i<c;i++) if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
				parent.pages.document.f.elements["zt"+i].value=qcm.theme[a].question[b].reponse[i].resultat[0];
			}
		}
		flag=1;
		timer=setTimeout("p2_clignoter()",300);
	}
	else {
		if (qcm.theme[a].question[b].type=="cases a cocher") {
			for (var i=0;i<c;i++) parent.pages.document.f.elements["case"+i].checked=false;
		}
		else if (qcm.theme[a].question[b].type=="boutons radio") {
			for (var i=0;i<c;i++) parent.pages.document.f.ch_rep[i].checked=false;
		}
		else if (qcm.theme[a].question[b].type=="glisser dposer images") {
			lignereponse=parent.pages.document.getElementById("rcpTD");
			cells = lignereponse.getElementsByTagName("td");
				for(var i=0;i<cells.length;i++){
					  	cells[i].innerHTML = "<img src='"+qcm.theme[a].question[b].reponse[i].image+"' style='border=1 float:left width= '"+qcm.theme[a].question[b].reponse[i].larg+" height='"+qcm.theme[a].question[b].reponse[i].haut+"' alt=''>";
						parent.pages.document.getElementById("rcpTD").style.visibility='Hidden';
					}
		}
		else {
			for (var i=0;i<c;i++) if (qcm.theme[a].question[b].reponse[i].resultat[0]!="") {
				if (qcm.theme[a].question[b].reponse[i].repondu=="faux") {
					parent.pages.document.f.elements["zt"+i].value="";
				}
			}
		}
		flag=0;
		timer=setTimeout("p2_clignoter()",100);
	}
}

// FONCTIONS APPELEES DEPUIS PLUSIEURS PAGES

	function afficher_page() {
		if (activite.num_affichage==1) {
			activite.num_affichage=2;
			parent.pages.location="page2.html";
			   // NewWindow = window.open("page2.html","test","toolbar=0,location=0,directories=0,status=0,menubar=0");
 //toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,copyhistory=0,width=550,height=550,top=100,left=200
    // Creation de la propriete creator permettant de referencer  
    //     la fenetre source
    //NewWindow.creator=self;
		}
		else {
			activite.num_affichage=1;
			parent.pages.location="page1.html";
			//NewWindow = window.open("page1.html","test","toolbar=0,location=0,directories=0,status=0,menubar=0");
 //toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,copyhistory=0,width=550,height=550,top=100,left=200
    // Creation de la propriete creator permettant de referencer  
    //     la fenetre source
    //NewWindow.creator=self;
		}
	}

	function nouvelle_question() {
		// Arrt du clignotement des cases  cocher.
		clearTimeout(timer);
		flag=1;
		if (option.mode_questions==1) {
			// Choix d'une comptence disponible pris au hasard.
			var a=Math.floor(qcm.theme.length*Math.random());
			while (qcm.theme[a].choisi=="non"||qcm.theme[a].etat=="fini") {
				a=Math.floor(qcm.theme.length*Math.random());
			}
			activite.num_theme=a;
			// Choix d'une question disponible prise au hasard.
			var b=Math.floor(qcm.theme[a].question.length*Math.random());
			while (qcm.theme[a].question[b].etat!="libre") {
				b=Math.floor(qcm.theme[a].question.length*Math.random());
			}
			activite.num_question=b;
		}
		if (option.mode_questions==2) {
			// Choix de la 1ere comptence disponible.
			var a=0;
			while (qcm.theme[a].etat=="fini") a++;
			activite.num_theme=a;
			// Choix de la 1ere question disponible.
			var b=0;
			while (qcm.theme[a].question[b].etat!="libre") b++;
			activite.num_question=b;
		}
		qcm.theme[a].question[b].etat="affichee";
		// Vrification de la comptence pour savoir si elle est termine ou non.
		qcm.theme[a].etat="fini";
		for (var i=0;i<qcm.theme[a].question.length;i++) {
			if (qcm.theme[a].question[i].etat=="libre") qcm.theme[a].etat="libre";
		}
		ecrire_page2();
	}
	
function sup_esp(ent) {
	var test=ent.substring(ent.length-1,ent.length);
	while (test==" ") {
		ent=ent.substring(0,ent.length-1);
		test=ent.substring(ent.length-1,ent.length);
	}
	test=ent.substring(0,1);
	while (test==" ") {
		ent=ent.substring(1,ent.length);
		test=ent.substring(0,1);
	}
	return ent;
}

function ouvrir_fenetre(adresse) {
	if (fen_guide!=null) {if (fen_guide.closed==false) fen_guide.close();}
	var largeur=screen.width/1.3;
	var hauteur=screen.height/1.5;
	var pos_x=(screen.width-largeur)/2;
	var pos_y=(screen.height-hauteur)/3;
	var dimensions='width='+largeur+',height='+hauteur+',left='+pos_x+',top='+pos_y;
	var proprietes='menubar=no,toolbar=no,directories=no,location=no,status=no,scrollbars=yes';
	fen_guide=window.open(adresse,'options',dimensions+proprietes);
	fen_guide.focus();
}

function entree_clavier(e) {
	var touche=(window.Event) ? e.which : e.keyCode;
	var keyPressed=String.fromCharCode(touche);
	if (keyPressed=="\r") {
		if (activite.num_page=="2") {
			var a=activite.num_theme;
			var b=activite.num_question;
			if (qcm.theme[a].question[b].type!="cases a cocher" && qcm.theme[a].question[b].type!="boutons radio") {
				p2_verifier();
			}
		}
		else if (activite.num_page=="2bis") p2_suivant();
	}
}

function hasard(ch) {
	var pos=ch.indexOf("||");
	if (pos!=-1) {
		var enonce=new Array();
		while (pos!=-1) {
			enonce[enonce.length]=ch.substring(0,pos);
			ch=ch.substring(pos+2,ch.length);
			pos=ch.indexOf("||");
			if (pos==-1) enonce[enonce.length]=ch;
		}
		var nb=Math.floor(enonce.length*Math.random());
		ch=enonce[nb];
	}
	return ch;
}

function quitter_qcm() {
	if (fen_guide!=null) {if (fen_guide.closed==false) fen_guide.close();}
	if (option.conseil_fin!="") {
		var cons=hasard(option.conseil_fin);
		alert(cons);
	}
	if (option.quitter=="") window.top.close();
	else window.top.location.href=option.quitter;
}







ob=[] // tableau des objets
function selObj(e){ // slection de l'objet sous la souris
el=ie?event.srcElement:e.target;
if(!el.tagName)el=el.parentNode // pour NS6+
}

function drag(e){
selObj(e);
if (el.id.substr(0,2)=="dd" && ob==D){  // si l'objet est dplaable
  ob=el;el=D; // le capture
  if(ob.parentNode.parentNode.id == "rcpDIV"){ // vite la case vide
    ob.parentNode.style.width = "1.5em";
    }
  }
return false // necessaire Gecko
}













